﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;

namespace XamDataChartYAxisLabelsCase
{
    public class CustomLabel : ContentControl
    {

        private TextBlock textBlock = new TextBlock();

        public CustomLabel()
        {
            this.Content = textBlock;
        }

        public XamDataChart Chart
        {
            get { return (XamDataChart)GetValue(ChartProperty); }
            set { SetValue(ChartProperty, value); }
        }

        // Using a DependencyProperty as the backing store for MyProperty.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ChartProperty =
            DependencyProperty.Register("Chart", typeof(XamDataChart), typeof(CustomLabel), new PropertyMetadata(null, new PropertyChangedCallback(ChartChanged)));

        static void ChartChanged(DependencyObject o, DependencyPropertyChangedEventArgs e)
        {
            CustomLabel cl = o as CustomLabel;
            cl.UpdateLabel();
        }



        public object Item
        {
            get { return (object)GetValue(ItemProperty); }
            set { SetValue(ItemProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Item.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ItemProperty =
            DependencyProperty.Register("Item", typeof(object), typeof(CustomLabel), new PropertyMetadata(null, new PropertyChangedCallback(ItemChanged)));

        static void ItemChanged(DependencyObject o, DependencyPropertyChangedEventArgs e)
        {
            CustomLabel cl = o as CustomLabel;
            cl.UpdateLabel();
        }



        public void UpdateLabel()
        {
            if (Chart != null && Item != null)
            {
                int i = int.Parse(Item.ToString());
                ViewModel VM = Chart.DataContext as ViewModel;

                SampleData SD = VM.Data.Where(sd => sd.Value == i).FirstOrDefault();

                if (SD != null)
                {
                    textBlock.Text = SD.YAxisLabel;
                }
            }
        }
    }
}
